// DO NOT MODIFY OR SUBMIT THIS FILE.

const courses = [
  { "number": "CS 101", "title": "Introduction to Computer Science", "prerequisites": [],
    "description": "How to think like a computer scientist. Topics include an overview of the context of computing, computational operations, computational devices, algorithms and data structures, the storage and transmission of data, the presentation of information, and the limits of computing. Students learn about the design and implementation of computational systems, the value of abstraction, problem solving and the ways in which computation impacts society." },
  { "number": "CS 149", "title": "Introduction to Programming", "prerequisites": [],
    "description": "Fundamental problem-solving techniques using a modern programming language. Topics include variables, input/output, decisions, loops, functions, arrays, and objects. Students learn about algorithm development, testing strategies, and software tools. You may only enroll in CS 149 at most twice." },
  { "number": "CS 159", "title": "Advanced Programming", "prerequisites": [ "CS 149" ],
    "description": "Students use advanced problem-solving strategies to develop algorithms using classes and objects and techniques such as recursion, exceptions and file I/O.  This course also focuses on designing small applications and effective testing strategies. You may only enroll in CS 159 at most twice." },
  { "number": "CS 227", "title": "Discrete Structures I", "prerequisites": [ "CS 149" ],
    "description": "An introduction to discrete mathematical structures including functions, relations, sets, logic, matrices, elementary number theory, proof techniques, basics of counting, graphic theory, discrete probability, digital logic, finite state machines, integer and floating point representations." },
  { "number": "CS 240", "title": "Algorithms and Data Structures", "prerequisites": [ "CS 159", "CS 227" ],
    "description": "Students learn how to implement stacks, queues, lists, sets and maps using arrays, linked lists, binary trees, heaps, binary search trees, balanced trees and hashing. Students study graph representations and algorithms. Students analyze recursive and non-recursive algorithms, illustrated by various searching and sorting algorithms. Additional topics may be included as time permits. You may only enroll in CS 240 at most twice." },
  { "number": "CS 261", "title": "Computer Systems I", "prerequisites": [ "CS 159", "CS 227" ],
    "description": "This course provides an introduction to the operation of modern interrupt-driven computer systems. Explores the representation of software and information in binary memory, the primary components of a CPU, systems programming and basic interactions with an Operating System. You may only enroll in CS 261 at most twice." },
  { "number": "CS 280", "title": "Projects in Computer Science", "prerequisites": [],
    "description": "Projects or topics in computer science which are of interest to the lower division student. May be repeated for credit when course content changes. Topics may vary." },
  { "number": "CS 327", "title": "Discrete Structures II", "prerequisites": [ "CS 227", "CS 240" ],
    "description": "This course builds on the theoretical foundation developed in Discrete Structures I. Students study a range of topics from discrete mathematics and theoretical computer science including elementary number theory, matrices, graph theory, automata, computability and complexity theory." },
  { "number": "CS 330", "title": "Societal and Ethical Issues in Computing", "prerequisites": [],
    "description": "Overview of philosophical and professional ethics, and a survey of societal and ethical issues in computing such as privacy, intellectual property, computer security, computer crime, product liability, and the societal, environmental, and economic impact of computers. Students develop skills in assuming and defending positions on societal and ethical issues through oral presentations and written reports." },
  { "number": "CS 332", "title": "Technical Communication for Computer Science", "prerequisites": [],
    "description": "A study of the process of planning, researching, producing and revising technical documents for specific audiences in the computing industry.  Document forms studied include definitions, requirements specifications, design specifications, instructions, correspondence, descriptions, plans and reports. Specialized notations and languages are also considered." },
  { "number": "CS 343", "title": "Application Development", "prerequisites": [ "CS 159" ],
    "description": "Overview of application software development fundamentals and their use in building stand-alone applications, visualizing and interacting with complex data representations, and controlling the Internet of Things. This course provides an introduction to the technologies used to create modern user interfaces (e.g., web technologies), establishing a common foundation for later application-focused courses." },
  { "number": "CS 345", "title": "Software Engineering", "prerequisites": [ "CS 159" ],
    "description": "Study of modern methods and tools for the development of software products.  Topics include software development process models, software development tools, design and construction principles and practice, software quality assurance and program management." },
  { "number": "CS 347", "title": "Web Development", "prerequisites": [ "CS 343" ],
    "description": "This course covers design and development of World Wide Web applications.  Students examine protocols, architectures, development languages and facilities, and issues such as accessibility, usability, security and reliability.  Students work with a suite of development tools and languages to construct a client or server application that includes a GUI and a database." },
  { "number": "CS 349", "title": "Developing Interactive Multimedia", "prerequisites": [ "CS 240" ],
    "description": "Students learn the concepts of multimedia, the issues in designing multimedia to interact effectively with users, the performance and speed issues in designing multimedia and how to implement interactive multimedia applications." },
  { "number": "CS 354", "title": "Introduction to Autonomous Robotics", "prerequisites": [ "CS 240" ],
    "description": "A hands-on introduction to programming autonomous mobile robots. The focus of this course is on designing robotic systems that navigate independently in complex environments. Specific topics include localization, mapping, kinematics, path planning and computer vision." },
  { "number": "CS 361", "title": "Computer Systems II", "prerequisites": [ "CS 240", "CS 261" ],
    "description": "Intermediate exploration of modern interrupt-driven computer systems.  Explores models of computation and complex systems, techniques for communication and synchronization of parallel and concurrent software, and the protocols that make up the Internet." },
  { "number": "CS 374", "title": "Database Systems", "prerequisites": [ "CS 240", "CS 343" ],
    "description": "An introduction to database design and management with emphasis on data definition, data manipulation and query languages found in modern database management systems." },
  { "number": "CS 412", "title": "Applied Algorithms", "prerequisites": [ "CS 327" ],
    "description": "A practical study of algorithms and their use in problem solving. Algorithms are selected from categories including divide-and-conquer, greedy, backtracking, network flow and dynamic programming. The classes P and NP are introduced and intractable problems discussed. This is a programming intensive course." },
  { "number": "CS 430", "title": "Programming Languages", "prerequisites": [ "CS 240", "CS 261" ],
    "description": "Several actual programming languages are studied in terms of the fundamental principles of computer programming language design, including object-oriented programming, functional programming, concurrent programming and logic programming." },
  { "number": "CS 432", "title": "Compilers", "prerequisites": [ "CS 327", "CS 361" ],
    "description": "Introduction to the theory and implementation of compilers. Explores the lexical, syntactic, and semantic analysis of high-level language code as well as code generation, optimization techniques, and architectural or operating system considerations. Course work includes a significant programming component." },
  { "number": "CS 442", "title": "Logic in Computer Science", "prerequisites": [],
    "description": "An exploration of some of the many connections between logic and computing, such as the application of classical and temporal logic in program verification, logic and logic programming, decidability, computability, automatic theorem proving, the computational complexity of logic algorithms, and applications of logic in artificial intelligence. A course in discrete mathematics or logic is recommended as preparation for this course." },
  { "number": "CS 444", "title": "Artificial Intelligence", "prerequisites": [ "CS 240" ],
    "description": "Students will study the history, premises, goals, social impact and philosophical implications of artificial intelligence. Students will study heuristic algorithms for large state spaces and learn to develop recursive and non-deterministic algorithms." },
  { "number": "CS 445", "title": "Machine Learning", "prerequisites": [ "CS 327" ],
    "description": "An introduction to the field of machine learning. Explores key problems and algorithms in machine learning from both a theoretical and an applied perspective. Specific topics include supervised and unsupervised learning, anomaly detection, text mining and experimental design. Students who have completed BSAN 393, ISAT 341 and MATH 358 may also take this course." },
  { "number": "CS 446", "title": "Software Analysis and Design", "prerequisites": [ "CS 240", "CS 345" ],
    "description": "Contemporary software analysis and design methods, tools, notations, techniques, processes, principles and practices. Students solve analysis and design problems alone or in teams and present their work to their peers and the instructor." },
  { "number": "CS 447", "title": "Interaction Design", "prerequisites": [ "CS 343" ],
    "description": "Study of and practice with processes, principles, tools, models and techniques for designing interactions between humans and digital products and systems.  Topics include physiological and psychological factors affecting interaction design, interaction design processes, interaction models, styles and paradigms, design notations and representations, prototyping, and interaction design evaluation." },
  { "number": "CS 448", "title": "Numerical Analysis", "prerequisites": [],
    "description": "This course is the study and analysis of algorithms used to solve nonlinear equations and systems of linear and nonlinear equations. Students will learn iterative methods for matrices and Newton-type methods as well as numerical differential and integral calculus. Students will perform programming using a high-level language and/or software packages." },
  { "number": "CS 449", "title": "Numerical Analysis for Differential Equations", "prerequisites": [],
    "description": "Study and analysis of numerical techniques to solve ordinary and partial differential equations, including Euler, Runge-Kutta, Picard, finite-difference and finite-element methods. Programming using a high-level language and/or software packages." },
  { "number": "CS 450", "title": "Operating Systems", "prerequisites": [ "CS 361" ],
    "description": "Introduction to the design and implementation of modern operating systems.  Explores fundamental concepts of operating systems, memory management, virtualization, resource allocation, file systems and system protection mechanisms. Course work includes a significant programming component." },
  { "number": "CS 452", "title": "Design and Analysis of Algorithms", "prerequisites": [ "CS 327" ],
    "description": "An introduction to algorithm design techniques and the mathematical analysis of algorithms. Techniques covered include divide-and-conquer, greedy, backtracking, network flow and dynamic programming. The classes P and NP are introduced and intractable problems are discussed. This is a proof-intensive course." },
  { "number": "CS 455", "title": "Advanced Computer Networking", "prerequisites": [ "CS 361" ],
    "description": "An in-depth analysis of networking protocols and tools to capture, analyze and synthesize network traffic. Includes significant programming projects that simulate the operation of network protocols. Introduces the design principles and implementation of client-server network applications." },
  { "number": "CS 456", "title": "Computer Architecture", "prerequisites": [ "CS 361" ],
    "description": "Introduction to the design and implementation of modern CPU architectures.  Explores hardware-based parallel execution, quantitative performance evaluation, I/O interfacing techniques and hardware descriptor languages.  Course work includes a significant programming component." },
  { "number": "CS 457", "title": "Information Security", "prerequisites": [ "CS 361" ],
    "description": "This course covers the basic issues of information system security. The roles of planning, management, policies, procedures and personnel in protecting the confidentiality, integrity and availability of information are described. Specific threats (malicious code, network attacks and hostile content) and widely used countermeasures (access control, mechanisms, firewalls and intrusion detection systems) are also discussed." },
  { "number": "CS 458", "title": "Cyber Defense", "prerequisites": [ "CS 361", "CS 457" ],
    "description": "A hands-on, lab-based learning experience in which the students engage in a series of mini projects to perform security assessment, penetration testing and hardening of networked systems. Students also participate in a cyber defense exercise." },
  { "number": "CS 462", "title": "Network Applications Development", "prerequisites": [],
    "description": "Design and implementation of network-based applications using languages and architectures such as sockets, JAVA, TL1 and CORBA. Concepts in distributed processing, including synchronization of interprocess communication and management of replicated data. Analysis of performance issues related to distributed applications." },
  { "number": "CS 470", "title": "Parallel and Distributed Systems", "prerequisites": [ "CS 361" ],
    "description": "Introduction to parallel and distributed systems. Explores shared memory, cluster, grid, peer-to-peer, and cloud computing models along with parallel software patterns, distributed file systems and performance considerations.  Course work includes a significant programming component." },
  { "number": "CS 480", "title": "Selected Topics in Computer Science", "prerequisites": [ "CS 159" ],
    "description": "Topics in computer science which are of interest but not otherwise covered in the regular computer science offerings of the department. Offered only with the approval of the department head; may be repeated for credit when course content changes." },
  { "number": "CS 482", "title": "Selected Topics in Information Security", "prerequisites": [ "CS 240", "CS 261" ],
    "description": "Topics in information security. Offered only with the approval of the department head; may be repeated for credit when course content changes." },
  { "number": "CS 488", "title": "Computer Graphics Applications", "prerequisites": [ "CS 240", "CS 261" ],
    "description": "This course develops a computer graphics application package based on standard graphics functions as well as attributes of a graphical user interface. It includes experience in applying interactive computer graphics techniques to industrial problems." }
];
